import { curry, isEmpty } from 'ramda'
import cursorGet from './cursorGet'
import { Validator } from 'jsonschema'
import schemaPath from './schemaPath'

const v = new Validator()

const validateSchema = curry((tree, schema, path) => {
  let val = cursorGet(tree, path)
  let rule = schemaPath(path, schema)
  let result = v.validate(val, rule)
  if (isEmpty(result.errors)) {
    result.isValid = true
    return result
  } else {
    result.isValid = false
    return result
  }
})

export default validateSchema
